angular.module('beamng.stuff')

.controller('derbyController',['$log', '$scope', '$state', 'bngApi', 'storeData', function ($log, $scope, $state, bngApi, storeData) {
  var vm = this;

  $scope.opponents = [
	{id:7, name:"7 Cars"},
	{id:6, name:"6 Cars"},
	{id:5, name:"5 Cars"},
	{id:4, name:"4 Cars"},
	{id:3, name:"3 Cars"},
	{id:2, name:"2 Cars"},
	{id:1, name:"1 Car"}
	];
$scope.class = [
	{id:8, name:"F150 Moonhawk Mod"},
	{id:7, name:"Random"},
	{id:6, name:"Luxury/Sport Cars"},
	{id:5, name:"Compact Cars"},
	{id:4, name:"Mid-Size Cars"},
	{id:3, name:"Large Cars"},
	{id:2, name:"Truck Pickups/Vans/SUVs"},
	{id:1, name:"Heavy Semis"}
	];
$scope.states = [
	{id:5, name:"Stock Config"},
	{id:4, name:"Derby Config 2"},
	{id:3, name:"Derby Config"},
	{id:2, name:"Stripped Config"},
	{id:1, name:"Low-End Config"}
	];
  $scope.arenas = [
	{id:3, name:"Grass"},
	{id:2, name:"Concrete"},
	{id:1, name:"Free Fall"}
	];
 $scope.Selection = function(arg1,arg2,arg3,arg4) {
 	storeData.saveSelection(arg1,arg2,arg3,arg4);
    	bngApi.engineLua('derby_module_aicode.Selection(' + bngApi.serializeToLua(arg1) + ',' + bngApi.serializeToLua(arg2) + ',' + bngApi.serializeToLua(arg3) + ','+ bngApi.serializeToLua(arg4) + ')');
 } 
$scope.getSelection = function(){
	console.log('function call');
	$scope.selectedOpponent = storeData.getSelection1();
	$scope.selectedClass = storeData.getSelection2();
	$scope.selectedState = storeData.getSelection3();
	$scope.selectedArena = storeData.getSelection4();
}
$scope.$watch('$viewContentLoaded', function() {
	$scope.selectedOpponent = storeData.getSelection1();
	$scope.selectedClass = storeData.getSelection2();
	$scope.selectedState = storeData.getSelection3();
	$scope.selectedArena = storeData.getSelection4();

	$scope.Selection($scope.selectedOpponent,$scope.selectedClass,$scope.selectedState,$scope.selectedArena);
}); 
}])
.service("storeData", function(){
this.saveSelection = function(arg1,arg2,arg3,arg4){
this.arg1 = arg1;
this.arg2 = arg2;
this.arg3 = arg3;
this.arg4 = arg4;
}
this.getSelection1 = function() {
	if(this.arg1 === undefined){
	this.arg1 = 3;};
	return this.arg1;
}
this.getSelection2 = function() {
	if(this.arg2 === undefined){
	this.arg2 = 3;};
	return this.arg2;
}
this.getSelection3 = function() {
	if(this.arg3 === undefined){
	this.arg3 = 3;};
	return this.arg3;
}
this.getSelection4 = function() {
	if(this.arg4 === undefined){
	this.arg4 = 3;};
	return this.arg4;
}
})
;

